Hex Artifact Content

Artifact d1d316a9e229cb4cf894cbfe469250aab030eea3:


0000: 23 21 20 2f 62 69 6e 2f 62 61 73 68 0a 0a 69 66  #! /bin/bash..if
0010: 20 5b 20 21 20 2d 78 20 22 2e 2f 70 6c 61 74 66   [ ! -x "./platf
0020: 6f 72 6d 22 20 5d 3b 20 74 68 65 6e 0a 09 65 63  orm" ]; then..ec
0030: 68 6f 20 27 45 52 52 4f 52 3a 20 50 6c 61 74 66  ho 'ERROR: Platf
0040: 6f 72 6d 20 73 63 72 69 70 74 20 6e 6f 74 20 66  orm script not f
0050: 6f 75 6e 64 3a 20 2e 2f 70 6c 61 74 66 6f 72 6d  ound: ./platform
0060: 27 20 3e 26 32 0a 0a 09 65 78 69 74 20 31 0a 66  ' >&2...exit 1.f
0070: 69 0a 0a 43 4c 45 41 4e 4f 4e 4c 59 3d 30 0a 44  i..CLEANONLY=0.D
0080: 49 53 54 43 4c 45 41 4e 3d 30 0a 69 66 20 5b 20  ISTCLEAN=0.if [ 
0090: 22 24 31 22 20 3d 20 22 63 6c 65 61 6e 22 20 5d  "$1" = "clean" ]
00a0: 3b 20 74 68 65 6e 0a 09 73 68 69 66 74 0a 09 43  ; then..shift..C
00b0: 4c 45 41 4e 4f 4e 4c 59 3d 31 0a 66 69 0a 69 66  LEANONLY=1.fi.if
00c0: 20 5b 20 22 24 31 22 20 3d 20 22 64 69 73 74 63   [ "$1" = "distc
00d0: 6c 65 61 6e 22 20 5d 3b 20 74 68 65 6e 0a 09 73  lean" ]; then..s
00e0: 68 69 66 74 0a 09 43 4c 45 41 4e 4f 4e 4c 59 3d  hift..CLEANONLY=
00f0: 31 0a 09 44 49 53 54 43 4c 45 41 4e 3d 31 0a 66  1..DISTCLEAN=1.f
0100: 69 0a 65 78 70 6f 72 74 20 43 4c 45 41 4e 4f 4e  i.export CLEANON
0110: 4c 59 20 44 49 53 54 43 4c 45 41 4e 0a 0a 43 4f  LY DISTCLEAN..CO
0120: 4e 46 49 47 55 52 45 45 58 54 52 41 3d 22 24 40  NFIGUREEXTRA="$@
0130: 22 0a 65 78 70 6f 72 74 20 43 4f 4e 46 49 47 55  ".export CONFIGU
0140: 52 45 45 58 54 52 41 0a 0a 23 20 44 65 74 65 72  REEXTRA..# Deter
0150: 6d 69 6e 65 20 70 61 74 68 20 74 6f 20 22 74 63  mine path to "tc
0160: 6c 43 6f 6e 66 69 67 2e 73 68 22 0a 72 6d 20 2d  lConfig.sh".rm -
0170: 72 66 20 74 63 6c 2f 62 75 69 6c 64 20 74 63 6c  rf tcl/build tcl
0180: 2f 69 6e 73 74 2d 2a 0a 72 6d 20 2d 66 20 70 6c  /inst-*.rm -f pl
0190: 61 74 66 6f 72 6d 2e 6d 61 67 69 63 2e 2a 0a 72  atform.magic.*.r
01a0: 6d 20 2d 72 66 20 2a 2f 6f 75 74 0a 69 66 20 5b  m -rf */out.if [
01b0: 20 22 24 7b 44 49 53 54 43 4c 45 41 4e 7d 22 20   "${DISTCLEAN}" 
01c0: 3d 20 22 31 22 20 5d 3b 20 74 68 65 6e 0a 09 72  = "1" ]; then..r
01d0: 6d 20 2d 72 66 20 74 63 6c 0a 66 69 0a 0a 69 66  m -rf tcl.fi..if
01e0: 20 5b 20 22 24 7b 43 4c 45 41 4e 4f 4e 4c 59 7d   [ "${CLEANONLY}
01f0: 22 20 3d 20 22 30 22 20 5d 3b 20 74 68 65 6e 0a  " = "0" ]; then.
0200: 09 50 52 4f 4a 52 4f 4f 54 44 49 52 3d 22 24 28  .PROJROOTDIR="$(
0210: 70 77 64 29 22 0a 09 65 78 70 6f 72 74 20 50 52  pwd)"..export PR
0220: 4f 4a 52 4f 4f 54 44 49 52 0a 0a 09 66 6f 72 20  OJROOTDIR...for 
0230: 54 43 4c 56 45 52 53 20 69 6e 20 38 2e 35 2e 39  TCLVERS in 8.5.9
0240: 20 38 2e 34 2e 31 39 3b 20 64 6f 0a 09 09 54 43   8.4.19; do...TC
0250: 4c 53 48 4f 52 54 56 45 52 53 3d 22 24 28 65 63  LSHORTVERS="$(ec
0260: 68 6f 20 22 24 7b 54 43 4c 56 45 52 53 7d 22 20  ho "${TCLVERS}" 
0270: 7c 20 63 75 74 20 2d 66 20 31 2d 32 20 2d 64 20  | cut -f 1-2 -d 
0280: 27 2e 27 29 22 0a 09 09 54 43 4c 50 52 49 56 41  '.')"...TCLPRIVA
0290: 54 45 3d 22 24 28 70 77 64 29 2f 74 63 6c 2f 62  TE="$(pwd)/tcl/b
02a0: 75 69 6c 64 2f 74 63 6c 24 7b 54 43 4c 56 45 52  uild/tcl${TCLVER
02b0: 53 7d 22 0a 09 09 54 43 4c 49 4e 53 54 44 49 52  S}"...TCLINSTDIR
02c0: 3d 22 24 28 70 77 64 29 2f 74 63 6c 2f 69 6e 73  ="$(pwd)/tcl/ins
02d0: 74 2d 24 7b 54 43 4c 53 48 4f 52 54 56 45 52 53  t-${TCLSHORTVERS
02e0: 7d 22 0a 09 09 65 78 70 6f 72 74 20 54 43 4c 56  }"...export TCLV
02f0: 45 52 53 20 54 43 4c 50 52 49 56 41 54 45 20 54  ERS TCLPRIVATE T
0300: 43 4c 49 4e 53 54 44 49 52 0a 0a 09 09 6d 6b 64  CLINSTDIR....mkd
0310: 69 72 20 74 63 6c 20 74 63 6c 2f 62 75 69 6c 64  ir tcl tcl/build
0320: 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e 2f 64   >/dev/null 2>/d
0330: 65 76 2f 6e 75 6c 6c 0a 0a 09 09 69 66 20 5b 20  ev/null....if [ 
0340: 21 20 2d 66 20 22 74 63 6c 2f 73 72 63 2f 74 63  ! -f "tcl/src/tc
0350: 6c 24 7b 54 43 4c 56 45 52 53 7d 2e 74 61 72 2e  l${TCLVERS}.tar.
0360: 67 7a 22 20 5d 3b 20 74 68 65 6e 0a 09 09 09 6d  gz" ]; then....m
0370: 6b 64 69 72 20 74 63 6c 2f 73 72 63 20 3e 2f 64  kdir tcl/src >/d
0380: 65 76 2f 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f 6e  ev/null 2>/dev/n
0390: 75 6c 6c 0a 09 09 09 77 67 65 74 20 2d 6f 20 2f  ull....wget -o /
03a0: 64 65 76 2f 6e 75 6c 6c 20 2d 4f 20 22 74 63 6c  dev/null -O "tcl
03b0: 2f 73 72 63 2f 74 63 6c 24 7b 54 43 4c 56 45 52  /src/tcl${TCLVER
03c0: 53 7d 2e 74 61 72 2e 67 7a 22 20 22 68 74 74 70  S}.tar.gz" "http
03d0: 3a 2f 2f 70 72 64 6f 77 6e 6c 6f 61 64 73 2e 73  ://prdownloads.s
03e0: 6f 75 72 63 65 66 6f 72 67 65 2e 6e 65 74 2f 74  ourceforge.net/t
03f0: 63 6c 2f 74 63 6c 24 7b 54 43 4c 56 45 52 53 7d  cl/tcl${TCLVERS}
0400: 2d 73 72 63 2e 74 61 72 2e 67 7a 22 0a 09 09 66  -src.tar.gz"...f
0410: 69 0a 0a 09 09 65 63 68 6f 20 22 42 75 69 6c 64  i....echo "Build
0420: 69 6e 67 20 54 63 6c 20 24 7b 54 43 4c 56 45 52  ing Tcl ${TCLVER
0430: 53 7d 22 0a 09 09 28 0a 09 09 09 6d 6b 64 69 72  S}"...(....mkdir
0440: 20 74 63 6c 2f 62 75 69 6c 64 20 3e 2f 64 65 76   tcl/build >/dev
0450: 2f 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c  /null 2>/dev/nul
0460: 6c 0a 09 09 09 63 64 20 74 63 6c 2f 62 75 69 6c  l....cd tcl/buil
0470: 64 20 7c 7c 20 65 78 69 74 20 31 0a 09 09 09 67  d || exit 1....g
0480: 7a 69 70 20 2d 64 63 20 22 2e 2e 2f 73 72 63 2f  zip -dc "../src/
0490: 74 63 6c 24 7b 54 43 4c 56 45 52 53 7d 2e 74 61  tcl${TCLVERS}.ta
04a0: 72 2e 67 7a 22 20 7c 20 74 61 72 20 2d 78 66 20  r.gz" | tar -xf 
04b0: 2d 0a 0a 09 09 09 23 20 44 44 45 20 61 6e 64 20  -.....# DDE and 
04c0: 52 65 67 20 63 61 6e 20 66 61 69 6c 20 74 6f 20  Reg can fail to 
04d0: 63 6f 6d 70 69 6c 65 2c 20 62 75 74 20 77 65 20  compile, but we 
04e0: 64 6f 6e 27 74 20 63 61 72 65 0a 09 09 09 65 63  don't care....ec
04f0: 68 6f 20 27 27 20 3e 20 22 24 7b 54 43 4c 50 52  ho '' > "${TCLPR
0500: 49 56 41 54 45 7d 2f 77 69 6e 2f 74 63 6c 57 69  IVATE}/win/tclWi
0510: 6e 44 64 65 2e 63 22 0a 09 09 09 65 63 68 6f 20  nDde.c"....echo 
0520: 27 27 20 3e 20 22 24 7b 54 43 4c 50 52 49 56 41  '' > "${TCLPRIVA
0530: 54 45 7d 2f 77 69 6e 2f 74 63 6c 57 69 6e 52 65  TE}/win/tclWinRe
0540: 67 2e 63 22 0a 0a 09 09 09 66 6f 72 20 64 69 72  g.c".....for dir
0550: 20 69 6e 20 75 6e 69 78 20 77 69 6e 20 6d 61 63   in unix win mac
0560: 6f 73 78 3b 20 64 6f 0a 09 09 09 09 63 64 20 22  osx; do.....cd "
0570: 24 7b 54 43 4c 50 52 49 56 41 54 45 7d 2f 24 7b  ${TCLPRIVATE}/${
0580: 64 69 72 7d 22 20 7c 7c 20 65 78 69 74 20 31 0a  dir}" || exit 1.
0590: 0a 09 09 09 09 65 63 68 6f 20 22 20 45 78 65 63  .....echo " Exec
05a0: 75 74 69 6e 67 3a 20 2e 2f 63 6f 6e 66 69 67 75  uting: ./configu
05b0: 72 65 20 2d 2d 65 6e 61 62 6c 65 2d 74 68 72 65  re --enable-thre
05c0: 61 64 73 20 24 7b 43 4f 4e 46 49 47 55 52 45 45  ads ${CONFIGUREE
05d0: 58 54 52 41 7d 20 2d 2d 70 72 65 66 69 78 3d 5c  XTRA} --prefix=\
05e0: 22 24 7b 54 43 4c 49 4e 53 54 44 49 52 7d 5c 22  "${TCLINSTDIR}\"
05f0: 22 0a 09 09 09 09 2e 2f 63 6f 6e 66 69 67 75 72  "....../configur
0600: 65 20 2d 2d 65 6e 61 62 6c 65 2d 74 68 72 65 61  e --enable-threa
0610: 64 73 20 24 7b 43 4f 4e 46 49 47 55 52 45 45 58  ds ${CONFIGUREEX
0620: 54 52 41 7d 20 2d 2d 70 72 65 66 69 78 3d 22 24  TRA} --prefix="$
0630: 7b 54 43 4c 49 4e 53 54 44 49 52 7d 22 0a 0a 09  {TCLINSTDIR}"...
0640: 09 09 09 65 63 68 6f 20 22 20 45 78 65 63 75 74  ...echo " Execut
0650: 69 6e 67 3a 20 24 7b 4d 41 4b 45 3a 2d 6d 61 6b  ing: ${MAKE:-mak
0660: 65 7d 22 0a 09 09 09 09 24 7b 4d 41 4b 45 3a 2d  e}".....${MAKE:-
0670: 6d 61 6b 65 7d 20 7c 7c 20 63 6f 6e 74 69 6e 75  make} || continu
0680: 65 0a 0a 09 09 09 09 65 63 68 6f 20 22 20 45 78  e......echo " Ex
0690: 65 63 75 74 69 6e 67 3a 20 24 7b 4d 41 4b 45 3a  ecuting: ${MAKE:
06a0: 2d 6d 61 6b 65 7d 20 69 6e 73 74 61 6c 6c 22 0a  -make} install".
06b0: 09 09 09 09 24 7b 4d 41 4b 45 3a 2d 6d 61 6b 65  ....${MAKE:-make
06c0: 7d 20 69 6e 73 74 61 6c 6c 20 7c 7c 20 62 72 65  } install || bre
06d0: 61 6b 0a 0a 09 09 09 09 4c 44 5f 4c 49 42 52 41  ak......LD_LIBRA
06e0: 52 59 5f 50 41 54 48 3d 22 2e 3a 24 7b 4c 44 5f  RY_PATH=".:${LD_
06f0: 4c 49 42 52 41 52 59 5f 50 41 54 48 7d 22 0a 09  LIBRARY_PATH}"..
0700: 09 09 09 4c 44 5f 52 55 4e 5f 50 41 54 48 3d 22  ...LD_RUN_PATH="
0710: 2e 3a 24 7b 4c 44 5f 52 55 4e 5f 50 41 54 48 7d  .:${LD_RUN_PATH}
0720: 22 0a 09 09 09 09 65 78 70 6f 72 74 20 4c 44 5f  ".....export LD_
0730: 4c 49 42 52 41 52 59 5f 50 41 54 48 20 4c 44 5f  LIBRARY_PATH LD_
0740: 52 55 4e 5f 50 41 54 48 0a 0a 09 09 09 09 66 69  RUN_PATH......fi
0750: 6c 65 20 74 63 6c 73 68 20 74 63 6c 73 68 2a 2e  le tclsh tclsh*.
0760: 65 78 65 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 20  exe 2>/dev/null 
0770: 7c 20 67 72 65 70 20 2d 69 76 20 27 4e 6f 20 73  | grep -iv 'No s
0780: 75 63 68 20 66 69 6c 65 27 20 3e 20 22 24 7b 50  uch file' > "${P
0790: 52 4f 4a 52 4f 4f 54 44 49 52 7d 2f 70 6c 61 74  ROJROOTDIR}/plat
07a0: 66 6f 72 6d 2e 6d 61 67 69 63 2e 66 69 6c 65 22  form.magic.file"
07b0: 0a 09 09 09 09 69 66 20 5b 20 2d 66 20 74 63 6c  .....if [ -f tcl
07c0: 73 68 2a 2e 65 78 65 20 5d 3b 20 74 68 65 6e 0a  sh*.exe ]; then.
07d0: 09 09 09 09 09 65 63 68 6f 20 27 70 75 74 73 20  .....echo 'puts 
07e0: 22 24 3a 3a 74 63 6c 5f 70 6c 61 74 66 6f 72 6d  "$::tcl_platform
07f0: 28 6f 73 29 22 27 20 7c 20 2e 2f 74 63 6c 73 68  (os)"' | ./tclsh
0800: 2a 2e 65 78 65 20 3e 20 22 24 7b 50 52 4f 4a 52  *.exe > "${PROJR
0810: 4f 4f 54 44 49 52 7d 2f 70 6c 61 74 66 6f 72 6d  OOTDIR}/platform
0820: 2e 6d 61 67 69 63 2e 6f 73 22 20 32 3e 2f 64 65  .magic.os" 2>/de
0830: 76 2f 6e 75 6c 6c 0a 09 09 09 09 65 6c 73 65 0a  v/null.....else.
0840: 09 09 09 09 09 65 63 68 6f 20 27 70 75 74 73 20  .....echo 'puts 
0850: 22 24 3a 3a 74 63 6c 5f 70 6c 61 74 66 6f 72 6d  "$::tcl_platform
0860: 28 6f 73 29 22 27 20 7c 20 2e 2f 74 63 6c 73 68  (os)"' | ./tclsh
0870: 20 3e 20 22 24 7b 50 52 4f 4a 52 4f 4f 54 44 49   > "${PROJROOTDI
0880: 52 7d 2f 70 6c 61 74 66 6f 72 6d 2e 6d 61 67 69  R}/platform.magi
0890: 63 2e 6f 73 22 20 32 3e 2f 64 65 76 2f 6e 75 6c  c.os" 2>/dev/nul
08a0: 6c 0a 09 09 09 09 66 69 0a 09 09 09 09 65 63 68  l.....fi.....ech
08b0: 6f 20 22 24 7b 64 69 72 7d 22 20 3e 20 22 24 7b  o "${dir}" > "${
08c0: 50 52 4f 4a 52 4f 4f 54 44 49 52 7d 2f 70 6c 61  PROJROOTDIR}/pla
08d0: 74 66 6f 72 6d 2e 6d 61 67 69 63 2e 70 6c 61 74  tform.magic.plat
08e0: 66 6f 72 6d 22 0a 09 09 09 09 70 77 64 20 3e 20  form".....pwd > 
08f0: 22 24 7b 50 52 4f 4a 52 4f 4f 54 44 49 52 7d 2f  "${PROJROOTDIR}/
0900: 70 6c 61 74 66 6f 72 6d 2e 6d 61 67 69 63 2e 64  platform.magic.d
0910: 69 72 22 0a 0a 09 09 09 09 62 72 65 61 6b 0a 09  ir"......break..
0920: 09 09 64 6f 6e 65 0a 0a 09 09 09 65 78 69 74 20  ..done.....exit 
0930: 30 0a 09 09 29 20 3e 20 22 74 63 6c 2f 62 75 69  0...) > "tcl/bui
0940: 6c 64 2f 62 75 69 6c 64 2d 24 7b 54 43 4c 56 45  ld/build-${TCLVE
0950: 52 53 7d 2e 6c 6f 67 22 20 32 3e 26 31 20 7c 7c  RS}.log" 2>&1 ||
0960: 20 28 0a 09 09 09 65 63 68 6f 20 22 46 61 69 6c   (....echo "Fail
0970: 65 64 20 74 6f 20 62 75 69 6c 64 20 54 63 6c 2e  ed to build Tcl.
0980: 20 20 53 65 65 20 5c 22 2e 2f 74 63 6c 2f 62 75    See \"./tcl/bu
0990: 69 6c 64 2f 62 75 69 6c 64 2d 24 7b 54 43 4c 56  ild/build-${TCLV
09a0: 45 52 53 7d 2e 6c 6f 67 5c 22 22 20 3e 26 32 0a  ERS}.log\"" >&2.
09b0: 09 09 09 65 63 68 6f 20 27 41 62 6f 72 74 69 6e  ...echo 'Abortin
09c0: 67 2e 27 20 3e 26 32 0a 0a 09 09 09 65 78 69 74  g.' >&2.....exit
09d0: 20 31 0a 09 09 29 20 7c 7c 20 65 78 69 74 20 31   1...) || exit 1
09e0: 0a 0a 09 09 28 0a 09 09 09 54 43 4c 42 55 49 4c  ....(....TCLBUIL
09f0: 44 44 49 52 3d 22 24 28 63 61 74 20 22 24 7b 50  DDIR="$(cat "${P
0a00: 52 4f 4a 52 4f 4f 54 44 49 52 7d 2f 70 6c 61 74  ROJROOTDIR}/plat
0a10: 66 6f 72 6d 2e 6d 61 67 69 63 2e 64 69 72 22 29  form.magic.dir")
0a20: 22 0a 09 09 09 65 78 70 6f 72 74 20 54 43 4c 42  "....export TCLB
0a30: 55 49 4c 44 44 49 52 0a 0a 09 09 09 69 66 20 5b  UILDDIR.....if [
0a40: 20 2d 64 20 22 24 7b 54 43 4c 49 4e 53 54 44 49   -d "${TCLINSTDI
0a50: 52 7d 22 20 2d 61 20 2d 66 20 22 24 7b 54 43 4c  R}" -a -f "${TCL
0a60: 49 4e 53 54 44 49 52 7d 2f 6c 69 62 2f 74 63 6c  INSTDIR}/lib/tcl
0a70: 43 6f 6e 66 69 67 2e 73 68 22 20 5d 3b 20 74 68  Config.sh" ]; th
0a80: 65 6e 0a 09 09 09 09 54 43 4c 43 4f 4e 46 49 47  en.....TCLCONFIG
0a90: 44 49 52 3d 22 24 7b 54 43 4c 49 4e 53 54 44 49  DIR="${TCLINSTDI
0aa0: 52 7d 2f 6c 69 62 22 0a 09 09 09 65 6c 69 66 20  R}/lib"....elif 
0ab0: 5b 20 2d 64 20 22 24 7b 54 43 4c 42 55 49 4c 44  [ -d "${TCLBUILD
0ac0: 44 49 52 7d 22 20 2d 61 20 2d 66 20 22 24 7b 54  DIR}" -a -f "${T
0ad0: 43 4c 42 55 49 4c 44 44 49 52 7d 2f 74 63 6c 43  CLBUILDDIR}/tclC
0ae0: 6f 6e 66 69 67 2e 73 68 22 20 5d 3b 20 74 68 65  onfig.sh" ]; the
0af0: 6e 0a 09 09 09 09 54 43 4c 43 4f 4e 46 49 47 44  n.....TCLCONFIGD
0b00: 49 52 3d 22 24 7b 54 43 4c 42 55 49 4c 44 44 49  IR="${TCLBUILDDI
0b10: 52 7d 22 0a 09 09 09 65 6c 73 65 0a 09 09 09 09  R}"....else.....
0b20: 65 63 68 6f 20 27 55 6e 61 62 6c 65 20 74 6f 20  echo 'Unable to 
0b30: 66 69 6e 64 20 61 70 70 72 6f 70 72 69 61 74 65  find appropriate
0b40: 20 74 63 6c 43 6f 6e 66 69 67 2e 73 68 2c 20 61   tclConfig.sh, a
0b50: 62 6f 72 74 69 6e 67 27 20 3e 26 32 0a 0a 09 09  borting' >&2....
0b60: 09 09 65 78 69 74 20 31 0a 09 09 09 66 69 0a 0a  ..exit 1....fi..
0b70: 09 09 09 41 44 44 46 4c 41 47 53 3d 22 22 0a 09  ...ADDFLAGS=""..
0b80: 09 09 69 66 20 5b 20 2d 6e 20 22 24 7b 54 43 4c  ..if [ -n "${TCL
0b90: 50 52 49 56 41 54 45 7d 22 20 5d 3b 20 74 68 65  PRIVATE}" ]; the
0ba0: 6e 0a 09 09 09 09 41 44 44 46 4c 41 47 53 3d 22  n.....ADDFLAGS="
0bb0: 24 7b 41 44 44 46 4c 41 47 53 7d 20 2d 49 24 7b  ${ADDFLAGS} -I${
0bc0: 54 43 4c 50 52 49 56 41 54 45 7d 20 2d 49 24 7b  TCLPRIVATE} -I${
0bd0: 54 43 4c 50 52 49 56 41 54 45 7d 2f 67 65 6e 65  TCLPRIVATE}/gene
0be0: 72 69 63 22 0a 09 09 09 66 69 0a 09 09 09 69 66  ric"....fi....if
0bf0: 20 5b 20 2d 6e 20 22 24 7b 54 43 4c 42 55 49 4c   [ -n "${TCLBUIL
0c00: 44 44 49 52 7d 22 20 5d 3b 20 74 68 65 6e 0a 09  DDIR}" ]; then..
0c10: 09 09 09 41 44 44 46 4c 41 47 53 3d 22 24 7b 41  ...ADDFLAGS="${A
0c20: 44 44 46 4c 41 47 53 7d 20 2d 49 24 7b 54 43 4c  DDFLAGS} -I${TCL
0c30: 42 55 49 4c 44 44 49 52 7d 22 0a 09 09 09 66 69  BUILDDIR}"....fi
0c40: 0a 09 09 09 43 46 4c 41 47 53 3d 22 24 7b 41 44  ....CFLAGS="${AD
0c50: 44 46 4c 41 47 53 7d 20 24 7b 43 46 4c 41 47 53  DFLAGS} ${CFLAGS
0c60: 7d 22 0a 09 09 09 43 50 50 46 4c 41 47 53 3d 22  }"....CPPFLAGS="
0c70: 24 7b 41 44 44 46 4c 41 47 53 7d 20 24 7b 43 50  ${ADDFLAGS} ${CP
0c80: 50 46 4c 41 47 53 7d 22 0a 0a 09 09 09 75 6e 73  PFLAGS}".....uns
0c90: 65 74 20 54 43 4c 56 45 52 53 0a 09 09 09 75 6e  et TCLVERS....un
0ca0: 73 65 74 20 41 44 44 46 4c 41 47 53 0a 09 09 09  set ADDFLAGS....
0cb0: 65 78 70 6f 72 74 20 54 43 4c 42 55 49 4c 44 44  export TCLBUILDD
0cc0: 49 52 20 54 43 4c 43 4f 4e 46 49 47 44 49 52 20  IR TCLCONFIGDIR 
0cd0: 54 43 4c 50 52 49 56 41 54 45 20 43 46 4c 41 47  TCLPRIVATE CFLAG
0ce0: 53 20 43 50 50 46 4c 41 47 53 0a 0a 09 09 09 72  S CPPFLAGS.....r
0cf0: 6d 20 2d 66 20 22 24 7b 50 52 4f 4a 52 4f 4f 54  m -f "${PROJROOT
0d00: 44 49 52 7d 2f 70 6c 61 74 66 6f 72 6d 2e 6d 61  DIR}/platform.ma
0d10: 67 69 63 2e 65 6e 76 2d 24 7b 54 43 4c 53 48 4f  gic.env-${TCLSHO
0d20: 52 54 56 45 52 53 7d 22 0a 09 09 09 73 65 74 20  RTVERS}"....set 
0d30: 3e 20 22 24 7b 50 52 4f 4a 52 4f 4f 54 44 49 52  > "${PROJROOTDIR
0d40: 7d 2f 70 6c 61 74 66 6f 72 6d 2e 6d 61 67 69 63  }/platform.magic
0d50: 2e 65 6e 76 2d 24 7b 54 43 4c 53 48 4f 52 54 56  .env-${TCLSHORTV
0d60: 45 52 53 7d 22 0a 09 09 09 65 78 70 6f 72 74 20  ERS}"....export 
0d70: 3e 3e 20 22 24 7b 50 52 4f 4a 52 4f 4f 54 44 49  >> "${PROJROOTDI
0d80: 52 7d 2f 70 6c 61 74 66 6f 72 6d 2e 6d 61 67 69  R}/platform.magi
0d90: 63 2e 65 6e 76 2d 24 7b 54 43 4c 53 48 4f 52 54  c.env-${TCLSHORT
0da0: 56 45 52 53 7d 22 0a 09 09 29 0a 09 64 6f 6e 65  VERS}"...)..done
0db0: 0a 0a 09 72 6d 20 2d 66 20 22 24 7b 50 52 4f 4a  ...rm -f "${PROJ
0dc0: 52 4f 4f 54 44 49 52 7d 2f 70 6c 61 74 66 6f 72  ROOTDIR}/platfor
0dd0: 6d 2e 6d 61 67 69 63 2e 64 69 72 22 0a 66 69 0a  m.magic.dir".fi.
0de0: 0a 23 20 44 65 74 65 72 6d 69 6e 65 20 70 6c 61  .# Determine pla
0df0: 74 66 6f 72 6d 0a 69 66 20 5b 20 2d 7a 20 22 24  tform.if [ -z "$
0e00: 7b 46 4f 52 43 45 5f 50 4c 41 54 46 4f 52 4d 7d  {FORCE_PLATFORM}
0e10: 22 20 5d 3b 20 74 68 65 6e 0a 09 50 4c 41 54 46  " ]; then..PLATF
0e20: 4f 52 4d 3d 22 24 28 2e 2f 70 6c 61 74 66 6f 72  ORM="$(./platfor
0e30: 6d 29 22 0a 65 6c 73 65 0a 09 50 4c 41 54 46 4f  m)".else..PLATFO
0e40: 52 4d 3d 22 24 7b 46 4f 52 43 45 5f 50 4c 41 54  RM="${FORCE_PLAT
0e50: 46 4f 52 4d 7d 22 0a 66 69 0a 65 78 70 6f 72 74  FORM}".fi.export
0e60: 20 50 4c 41 54 46 4f 52 4d 0a 0a 23 20 42 75 69   PLATFORM..# Bui
0e70: 6c 64 20 61 6c 6c 20 61 70 70 72 6f 70 72 69 61  ld all appropria
0e80: 74 65 20 64 69 72 65 63 74 6f 72 69 65 73 0a 66  te directories.f
0e90: 61 69 6c 65 64 64 69 72 73 3d 22 22 0a 69 66 20  aileddirs="".if 
0ea0: 5b 20 2d 7a 20 22 24 7b 44 49 52 53 7d 22 20 5d  [ -z "${DIRS}" ]
0eb0: 3b 20 74 68 65 6e 0a 09 44 49 52 53 3d 22 60 65  ; then..DIRS="`e
0ec0: 63 68 6f 20 2a 2f 60 22 0a 09 50 4b 47 48 41 53  cho */`"..PKGHAS
0ed0: 48 43 4f 44 45 3d 27 27 0a 65 6c 73 65 0a 09 50  HCODE=''.else..P
0ee0: 4b 47 48 41 53 48 43 4f 44 45 3d 22 24 28 28 65  KGHASHCODE="$((e
0ef0: 63 68 6f 20 22 24 7b 44 49 52 53 7d 22 20 7c 20  cho "${DIRS}" | 
0f00: 74 72 20 27 20 27 20 22 5c 6e 22 20 7c 20 73 6f  tr ' ' "\n" | so
0f10: 72 74 20 7c 20 74 72 20 22 5c 6e 22 20 27 20 27  rt | tr "\n" ' '
0f20: 3b 20 65 63 68 6f 20 29 20 7c 20 73 65 64 20 27  ; echo ) | sed '
0f30: 73 40 5b 2f 20 5d 40 40 67 27 20 7c 20 6f 70 65  s@[/ ]@@g' | ope
0f40: 6e 73 73 6c 20 73 68 61 31 20 7c 20 61 77 6b 20  nssl sha1 | awk 
0f50: 27 7b 20 70 72 69 6e 74 20 24 31 20 7d 27 29 22  '{ print $1 }')"
0f60: 0a 66 69 0a 66 6f 72 20 64 69 72 20 69 6e 20 24  .fi.for dir in $
0f70: 7b 44 49 52 53 7d 3b 20 64 6f 0a 09 65 78 70 6f  {DIRS}; do..expo
0f80: 72 74 20 64 69 72 0a 0a 09 69 66 20 5b 20 21 20  rt dir...if [ ! 
0f90: 2d 66 20 22 24 7b 64 69 72 7d 2f 62 75 69 6c 64  -f "${dir}/build
0fa0: 2e 73 68 22 20 5d 3b 20 74 68 65 6e 0a 09 09 63  .sh" ]; then...c
0fb0: 6f 6e 74 69 6e 75 65 0a 09 66 69 0a 0a 09 69 66  ontinue..fi...if
0fc0: 20 5b 20 22 24 7b 43 4c 45 41 4e 4f 4e 4c 59 7d   [ "${CLEANONLY}
0fd0: 22 20 3d 20 22 30 22 20 5d 3b 20 74 68 65 6e 0a  " = "0" ]; then.
0fe0: 09 09 65 63 68 6f 20 22 42 75 69 6c 64 69 6e 67  ..echo "Building
0ff0: 20 24 7b 64 69 72 7d 22 0a 09 66 69 0a 0a 09 66   ${dir}"..fi...f
1000: 61 69 6c 65 64 3d 30 0a 09 28 0a 09 09 63 64 20  ailed=0..(...cd 
1010: 22 24 7b 64 69 72 7d 22 20 7c 7c 20 65 78 69 74  "${dir}" || exit
1020: 20 31 0a 0a 09 09 72 6d 20 2d 72 66 20 22 62 75   1....rm -rf "bu
1030: 69 6c 64 22 20 22 6f 75 74 22 0a 09 09 72 6d 20  ild" "out"...rm 
1040: 2d 66 20 66 61 69 6c 65 64 2d 2a 2e 6c 6f 67 0a  -f failed-*.log.
1050: 09 09 69 66 20 5b 20 22 24 7b 44 49 53 54 43 4c  ..if [ "${DISTCL
1060: 45 41 4e 7d 22 20 3d 20 22 31 22 20 5d 3b 20 74  EAN}" = "1" ]; t
1070: 68 65 6e 0a 09 09 09 72 6d 20 2d 72 66 20 22 73  hen....rm -rf "s
1080: 72 63 22 0a 09 09 66 69 0a 09 09 69 66 20 5b 20  rc"...fi...if [ 
1090: 22 24 7b 43 4c 45 41 4e 4f 4e 4c 59 7d 22 20 3d  "${CLEANONLY}" =
10a0: 20 22 31 22 20 5d 3b 20 74 68 65 6e 0a 09 09 09   "1" ]; then....
10b0: 65 78 69 74 20 30 0a 09 09 66 69 0a 0a 09 09 6d  exit 0...fi....m
10c0: 6b 64 69 72 20 2d 70 20 22 6f 75 74 2f 24 7b 50  kdir -p "out/${P
10d0: 4c 41 54 46 4f 52 4d 7d 22 20 3e 2f 64 65 76 2f  LATFORM}" >/dev/
10e0: 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c  null 2>/dev/null
10f0: 0a 0a 09 09 2e 2f 62 75 69 6c 64 2e 73 68 20 3e  ...../build.sh >
1100: 20 22 6f 75 74 2f 24 7b 50 4c 41 54 46 4f 52 4d   "out/${PLATFORM
1110: 7d 2f 62 75 69 6c 64 2e 6c 6f 67 22 20 32 3e 26  }/build.log" 2>&
1120: 31 20 7c 7c 20 65 78 69 74 20 31 0a 09 29 20 7c  1 || exit 1..) |
1130: 7c 20 66 61 69 6c 65 64 3d 31 0a 0a 09 69 66 20  | failed=1...if 
1140: 5b 20 22 24 7b 66 61 69 6c 65 64 7d 22 20 3d 20  [ "${failed}" = 
1150: 22 31 22 20 5d 3b 20 74 68 65 6e 0a 09 09 63 70  "1" ]; then...cp
1160: 20 22 24 7b 64 69 72 7d 2f 6f 75 74 2f 24 7b 50   "${dir}/out/${P
1170: 4c 41 54 46 4f 52 4d 7d 2f 62 75 69 6c 64 2e 6c  LATFORM}/build.l
1180: 6f 67 22 20 22 24 7b 64 69 72 7d 2f 66 61 69 6c  og" "${dir}/fail
1190: 65 64 2d 24 7b 50 4c 41 54 46 4f 52 4d 7d 2d 60  ed-${PLATFORM}-`
11a0: 68 6f 73 74 6e 61 6d 65 60 2e 6c 6f 67 22 0a 0a  hostname`.log"..
11b0: 09 09 72 6d 20 2d 72 66 20 22 24 7b 64 69 72 7d  ..rm -rf "${dir}
11c0: 2f 6f 75 74 22 0a 09 09 66 61 69 6c 65 64 64 69  /out"...faileddi
11d0: 72 73 3d 22 24 7b 66 61 69 6c 65 64 64 69 72 73  rs="${faileddirs
11e0: 7d 20 24 7b 64 69 72 7d 22 0a 09 09 65 63 68 6f  } ${dir}"...echo
11f0: 20 22 46 61 69 6c 65 64 20 74 6f 20 62 75 69 6c   "Failed to buil
1200: 64 20 24 7b 64 69 72 7d 22 0a 09 66 69 0a 64 6f  d ${dir}"..fi.do
1210: 6e 65 0a 0a 23 20 43 6c 65 61 6e 20 6d 61 67 69  ne..# Clean magi
1220: 63 2d 72 65 6c 61 74 65 64 20 66 69 6c 65 73 0a  c-related files.
1230: 72 6d 20 2d 66 20 70 6c 61 74 66 6f 72 6d 2e 6d  rm -f platform.m
1240: 61 67 69 63 2e 2a 0a 0a 23 20 43 6c 65 61 6e 75  agic.*..# Cleanu
1250: 70 20 69 73 20 64 6f 6e 65 20 61 74 20 74 68 69  p is done at thi
1260: 73 20 70 6f 69 6e 74 0a 69 66 20 5b 20 22 24 7b  s point.if [ "${
1270: 43 4c 45 41 4e 4f 4e 4c 59 7d 22 20 3d 20 22 31  CLEANONLY}" = "1
1280: 22 20 5d 3b 20 74 68 65 6e 0a 09 65 78 69 74 20  " ]; then..exit 
1290: 30 0a 66 69 0a 0a 23 20 4c 65 74 20 74 68 65 20  0.fi..# Let the 
12a0: 75 73 65 72 20 6b 6e 6f 77 20 77 68 61 74 20 66  user know what f
12b0: 61 69 6c 65 64 20 74 6f 20 62 75 69 6c 64 0a 69  ailed to build.i
12c0: 66 20 5b 20 2d 6e 20 22 24 7b 66 61 69 6c 65 64  f [ -n "${failed
12d0: 64 69 72 73 7d 22 20 5d 3b 20 74 68 65 6e 0a 09  dirs}" ]; then..
12e0: 65 63 68 6f 20 22 54 68 65 20 66 6f 6c 6c 6f 77  echo "The follow
12f0: 69 6e 67 20 66 61 69 6c 65 64 20 74 6f 20 62 75  ing failed to bu
1300: 69 6c 64 3a 24 7b 66 61 69 6c 65 64 64 69 72 73  ild:${faileddirs
1310: 7d 22 0a 66 69 0a 0a 23 20 43 72 65 61 74 65 20  }".fi..# Create 
1320: 74 61 72 66 69 6c 65 20 6f 66 20 62 75 69 6c 74  tarfile of built
1330: 20 70 61 63 6b 61 67 65 73 0a 44 41 54 45 43 4f   packages.DATECO
1340: 44 45 3d 22 24 28 64 61 74 65 20 2b 25 59 25 6d  DE="$(date +%Y%m
1350: 25 64 25 48 25 4d 29 22 0a 0a 69 66 20 5b 20 2d  %d%H%M)"..if [ -
1360: 7a 20 22 24 7b 50 4b 47 48 41 53 48 43 4f 44 45  z "${PKGHASHCODE
1370: 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 4f 55 54 46  }" ]; then..OUTF
1380: 49 4c 45 42 41 53 45 3d 22 74 63 6c 70 6b 67 73  ILEBASE="tclpkgs
1390: 2d 24 7b 50 4c 41 54 46 4f 52 4d 7d 2d 24 7b 44  -${PLATFORM}-${D
13a0: 41 54 45 43 4f 44 45 7d 22 0a 65 6c 73 65 0a 09  ATECODE}".else..
13b0: 4f 55 54 46 49 4c 45 42 41 53 45 3d 22 74 63 6c  OUTFILEBASE="tcl
13c0: 70 6b 67 73 2d 24 7b 50 4b 47 48 41 53 48 43 4f  pkgs-${PKGHASHCO
13d0: 44 45 7d 2d 24 7b 50 4c 41 54 46 4f 52 4d 7d 2d  DE}-${PLATFORM}-
13e0: 24 7b 44 41 54 45 43 4f 44 45 7d 22 0a 66 69 0a  ${DATECODE}".fi.
13f0: 74 61 72 20 2d 63 66 20 2d 20 2a 2f 6f 75 74 20  tar -cf - */out 
1400: 7c 20 62 7a 69 70 32 20 2d 39 63 20 3e 20 22 24  | bzip2 -9c > "$
1410: 7b 4f 55 54 46 49 4c 45 42 41 53 45 7d 2e 74 61  {OUTFILEBASE}.ta
1420: 72 2e 62 7a 32 22 0a 0a 65 78 69 74 20 30 0a     r.bz2"..exit 0.